Subject: Strange test suite behaviour since zsh 5.2-dev-1: C02cond.ztst no more reports its finishing
From: Axel Beckert <[email-masked]>
To: [email-masked]
Cc: Debian Zsh Maintainers <[email-masked]>
Date: Sun, 31 Jan 2016 21:19:34 +0100
List-Id: Zsh Workers List <zsh-workers.zsh.org>

Hi,

I've seen this locally only once (on x86_64) once (IIRC when enabling
-fPIE for one test build), but on x86 (32 bit) the following issue has
been observed on our (Debian Zsh Packaging Team) Jenkins since I pushd
5.2-dev-1
(http://jenkins.grml.org/view/Debian/job/zsh-binaries/architecture=i386/):

>From the log of the test suite (examples taken from
http://jenkins.grml.org/view/Debian/job/zsh-binaries/architecture=i386/251/console):

[…]
20:56:44 Running test: type of variable when created in arithmetic context
20:56:44 Test successful.
20:56:44 ../../Test/C01arith.ztst: all tests successful.
20:56:44 ../../Test/C02cond.ztst: starting.
20:56:44 Running test: -a cond
20:56:44 Test successful.
[…]
20:56:46 Running test: test with two arguments and a token
20:56:46 Test successful.
20:56:46 Running test: yet more old-fashioned test fix ups: prefer comparison to parentheses
20:56:46 ../../Test/C03traps.ztst: starting.
20:56:46 Running test: Nested `trap ... EXIT'
20:56:46 Test successful.
[…]

What I miss is the "Test successful." for "yet more old-fashioned test
fix ups: prefer comparison to parentheses" as well as the
"../../Test/C02cond.ztst: all tests successful.".

Even if "yet more old-fashioned test fix ups: prefer comparison to
parentheses" did fail, I'd expect that it at least reports that fact.
But it looks as if the whole test script just silently exits.

In comparison, the x86_64 test suite runs look fine (taken from
http://jenkins.grml.org/view/Debian/job/zsh-binaries/architecture=amd64/251/consoleFull):

[…]
20:47:55 Running test: type of variable when created in arithmetic context
20:47:55 Test successful.
20:47:55 ../../Test/C01arith.ztst: all tests successful.
20:47:55 ../../Test/C02cond.ztst: starting.
20:47:56 Running test: -a cond
20:47:56 Test successful.
[…]
20:47:58 Running test: yet more old-fashioned test fix ups: prefer comparison to parentheses
20:47:58 Test successful.
20:47:58 ../../Test/C02cond.ztst: all tests successful.
20:47:58 ../../Test/C03traps.ztst: starting.
20:47:58 Running test: Nested `trap ... EXIT'
20:47:58 Test successful.
[…]

Any ideas what could cause this silent exiting of a .ztst script and
why it only appears under certain (yet not 100% clear) conditions?

		Kind regards, Axel
-- 
/~\  Plain Text Ribbon Campaign                   | Axel Beckert
\ /  Say No to HTML in E-Mail and News            | [email-masked]  (Mail)
 X   See http://www.nonhtmlmail.org/campaign.html | [email-masked] (Mail+Jabber)
/ \  I love long mails: http://email.is-not-s.ms/ | http://abe.noone.org/ (Web)